@import "../global/var";
@import "../global/var-pages";

$historySectionHeight: 68px;

.testrun-info {
    .page {
        padding-bottom: 0;
        height: 100%;

        &-wrapper {
            overflow: hidden;
        }
    }
    &__history {
        height: $historySectionHeight;
    }

    &__container {
        height: calc(100% - #{$breadcrumbs-height + $title-height});
        margin-right: -#{$page-padding-right-left};
        margin-left: -#{$page-padding-right-left};
    }

    &__section {
        height: calc(100% - #{$historySectionHeight});
        border-top: 2px solid $gray8be;

        > div {
            height: 100%;
        }

        section,
        .tab-content,
        .history-tab,
        table {
            height: inherit;

            >*:not(.testrun-info__tab-video-section):not(thead):not(tbody) {
                height: inherit;
            }
        }

        .panel {
            border: none;
            box-shadow: none;
        }
    }

    &__status {
        &-icon {
            display: inline-block;
            position: relative;
            min-width: 38px;
            height: 16px;
            text-align: center;
            text-transform: uppercase;
            font-weight: 500;
            font-size: 12px;

            &:before,
            &:after {
                position: absolute;
                display: block;
                content: '';
                top: 0;
                height: 16px;
                width: 10px;
            }

            &:before {
                left: -10px;
                border-top-left-radius: 16px;
                border-bottom-left-radius: 16px;
            }

            &:after {
                right: -10px;
                border-top-right-radius: 16px;
                border-bottom-right-radius: 16px;
            }


            &._debug,
            &._debug:before,
            &._debug:after {
                background-color: rgba($blue-dark, 0.07);
                color: $blue-dark;
            }

            &._warn,
            &._warn:before,
            &._warn:after {
                background-color: $yellow-new;
                color: rgba($dark-new, 0.8);
            }

            &._error,
            &._fatal,
            &._error:before,
            &._error:after,
            &._fatal:before,
            &._fatal:after {
                background-color: $red-new;
                color: $white;
            }

            &._info,
            &._info:before,
            &._info:after {
                background-color: rgba($green-new, 0.07);
                color: $green-new;
            }

            &._trace,
            &._status,
            &._trace:before,
            &._trace:after,
            &._status:before,
            &._status:after {
                background-color: rgba($dark-new, 0.07);
                color: rgba($dark-new, 0.8);
            }

            &.button__text {
                font-size: 12px;
                line-height: 1.42857;
            }
        }

        &-button-icon {
            display: inline-block;
            min-width: 44px;
            border-radius: 2px;
            height: 16px;
            text-align: center;
            text-transform: uppercase;

            & + .selected-icon {
                display: inline-block;
                height: 18px;
                width: 16px;
                min-height: 14px;
                min-width: 14px;
                font-size: 14px;
                transform: translateY(-2px);
                color: $brand-primary;
            }
        }
    }

    &__tab {
        color: $medium-gray;
        font-size: 14.5px;
        font-weight: 500;
        text-transform: capitalize;

        &.md-active {
            color: $coal !important;
        }

        &-table {
            overflow: unset;
            height: auto;
            width: 100%;
            table-layout: fixed;

            &-wrapper {
                margin-bottom: 0;
                height: 100%;
                overflow: auto;
                padding-bottom: 10px !important;

                &._mobile {
                    width: 100%;
                }
            }

            &-row {
                min-height: 48px;
                display: flex;
                border-bottom: 1px solid rgba($gray3e5, 0.3);
                overflow: hidden;

                &._head {
                    text-transform: uppercase;
                    font-weight: 500;
                    background-color: #f7f7f7;
                    position: sticky;
                    top: 0;
                    z-index: 1;
                }
            }

            &-row._empty &-col {
                display: flex;
                align-items: center;
                justify-content: center;
                width: 100%;
            }

            &-col {
                display: flex;
                align-items: center;
                justify-content: center;
                position: relative;
                line-height: 16px;
                font-size: 12px;
                word-wrap: break-word;

                &._start,
                &._visuals {
                    flex: 0 0 100px;

                    &-wrapper {
                        position: absolute;
                        top: 0;
                        left: 0;
                        width: 100%;
                        height: 100%;
                        max-height: 76px;
                        display: flex;
                        align-items: center;
                        justify-content: center;
                        font-size: 12px;
                        color: $black;
                    }
                }

                &._visuals .image-placeholder {
                    position: absolute;
                    top: 0;
                    left: 0;
                    width: 100%;
                    height: 100%;
                    max-height: 76px;
                    display: flex;
                    align-items: center;
                    justify-content: center;
                }

                &._status {
                    flex: 0 0 100px;

                    &-wrapper {
                        position: absolute;
                        top: 0;
                        left: 0;
                        width: 100%;
                        height: 100%;
                        max-height: 76px;
                        display: flex;
                        justify-content: center;
                        align-items: center;
                    }

                    & ._button-icon {
                        margin-left: 2px;
                        transform: translateY(2px);
                        font-size: 14px;
                    }
                }

                &._action {
                    flex: 1 1 auto;
                    justify-content: start;
                    padding: 0 0 0 24px;
                    width: auto;

                    & .log_message {
                        font-size: 12px;
                        line-height: 24px;
                        color: $black;
                        word-break: break-all;
                    }

                    a {
                        white-space: nowrap;
                    }
                }

                &._menu {
                    position: relative;
                    flex: 0 0 40px;
                    align-items: flex-start;

                    & ._menu-wrapper {
                        position: absolute;
                        top: 0;
                        left: 0;
                        width: 100%;
                        height: 100%;
                        max-height: 76px;
                    }
                }
            }

            &-img {
                width: 32px;
                height: 32px;
                border-radius: 4px;
                white-space: nowrap;
                overflow: hidden;
                text-overflow: ellipsis;
                object-fit: cover;
                box-shadow: 0 0 3px 0 rgba($black, 0.3);

                &-wrapper._visuals {
                    padding: 8px !important;
                }
            }

            .md-button.md-icon-button {
                margin: auto;
            }
        }

        &-additional {
            position: relative;
            bottom: 0;
            margin: 0 16px 16px;

            .tab-additional {
                &__table {
                    width: 100%;
                    max-width: 100%;
                    table-layout: fixed;

                    &:not(:first-of-type) {
                        margin-top: 20px;
                    }

                    &-row {
                        & ._border-bottom {
                            border-bottom: 1px solid $gray3e5;
                        }
                    }

                    &-data {
                        &._status,
                        &._started,
                        &._duration,
                        &._test-owner,
                        &._platform,
                        &._labels,
                        &._tickets,
                        &._artifacts {
                            color: $gray57c;
                            width: 150px;
                            min-width: 150px;
                            font-size: 14px;
                        }

                        &._labels,
                        &._artifacts {
                            vertical-align: top;
                        }

                        &._status-info {
                            padding: 8px 0;
                        }

                        &._labels-spinner {
                            padding: 8px 0;
                            text-align: center;
                        }

                        @media screen and (min-width: 992px) and (max-width: 1200px) {
                            &._status {
                                width: 33%;
                            }

                            &._status-info {
                                padding: 8px 0;
                            }

                            &._issue {
                                & .button {
                                    padding-right: 0;

                                    & span.data-icon {
                                        margin-right: 0;
                                    }
                                }
                            }
                        }

                        @media screen and (max-width: 375px) {
                            &._status {
                                width: 34%;
                                padding-right: 4px;
                            }
                        }

                        &._started-data {
                            padding: 0;
                        }

                        &._issue {
                            width: 92px;
                            padding-right: 0;

                            & .button {
                                border: 0;
                                padding: 0;
                                background-color: transparent;
                                color: $brand-primary;

                                & .data-icon svg path {
                                    fill: $brand-primary;
                                }

                                & .data-icon {
                                    font-size: 18px;
                                    margin-right: 6px;
                                    margin-left: 0;
                                    transform: translateY(0px);
                                }

                                & span {
                                    font-size: 14px;
                                    vertical-align: middle;
                                }
                            }
                        }

                        &._tickets-info {
                            & .issue-references {
                                display: inline-block;

                                & a,
                                & span {
                                    margin-right: 20px;
                                }
                            }
                        }

                        &._artifacts-info {
                            & .artifact-link {
                                display: inline-block;
                                margin-right: 25px;
                                color: $gray57c;
                                text-decoration: underline;
                                font-size: 14px;
                                word-break: break-word;
                                &:hover {
                                    color: $black;
                                }
                            }
                        }

                        &._label {
                            font-weight: 400;
                            vertical-align: text-bottom;
                        }

                        & .data-icon {
                            font-size: 18px;
                            margin-right: 10px;
                            margin-left: 6px;
                            transform: translateY(2px);
                        }
                    }

                    &-content {
                        word-break: break-all;
                    }
                }

                &__label {
                    margin: 4px 16px 4px 0;

                    &,
                    .test-label {
                        max-width: 100%;
                    }

                    .test-label__item {
                        max-width: 100%;
                        white-space: nowrap;
                        overflow: hidden;
                        text-overflow: ellipsis;
                    }

                    &._label-less,
                    &._label-more {
                        display: inline-block;
                        vertical-align: middle;
                        max-height: 16px;
                        border-radius: 8px;
                        font-size: 0;
                        line-height: 16px;
                        padding: 0 8px;
                        color: $gray57c;
                        box-shadow: 0 0 0 1px $gray8be;
                        transition: background-color .15s ease-in-out;
                        background-color: $table-bg-hover;
                        border: 0;
                        text-align: center;
                        width: 32px;

                        &:hover {
                            text-decoration: none;
                            background-color: rgba($black, 0.1);
                        }

                        .material-icons {
                            font-size: 16px;
                            height: 16px;
                            width: 16px;
                            min-height: 16px;
                            min-width: 16px;
                            color: currentColor;
                        }
                    }

                    &-spinner {
                        &-wrapper {
                            text-align: center;
                        }
                    }
                }

                &__artifact {
                    &._artifact-less,
                    &._artifact-more {
                        display: inline-flex;
                        vertical-align: middle;
                        align-items: center;
                        max-height: 16px;
                        font-size: 0;
                        line-height: 16px;
                        padding: 0;
                        border: 0;
                        color: $gray57c;
                        background-color: transparent;
                        transition: color .15s ease-in-out;
                        span {
                            font-size: 12px;
                            line-height: 16px;
                            font-weight: 700;
                            text-decoration: underline;
                        }
                        &:hover {
                            color: $black;
                        }
                        .material-icons {
                            font-size: 16px;
                            height: 16px;
                            width: 16px;
                            min-height: 16px;
                            min-width: 16px;
                            color: currentColor;
                        }
                    }
                }

                &__menu {
                    .menu__button {
                        display: inline-block;
                        position: relative;
                        padding: 0 0 0 22px;

                        .button-text {
                            position: relative;
                            font-size: 14px;
                            line-height: 26px;
                            text-transform: capitalize;
                            vertical-align: top;

                            &::before {
                                content: '';
                                display: block;
                                position: absolute;
                                top: 2px;
                                left: -20px;
                                height: 12px;
                                width: 12px;
                                border-radius: 50%;
                            }

                            &._failed {
                                &::before {
                                    background-color: $red-new;
                                }
                            }

                            &._passed {
                                &::before {
                                    background-color: #43c480;
                                }
                            }

                            &._in_progress {
                                &::before {
                                    background-color: $blue-new;
                                }
                            }

                            &._skipped {
                                &::before {
                                    background-color: $yellow-light-new;
                                }
                            }

                            &._aborted {
                                &::before {
                                    background-color: $gray3e5;
                                }
                            }

                            &._unknown {
                                &::before {
                                    background-color: $gray57c;
                                }
                            }
                        }

                        .button-icon {
                            color: $dark-coal-new;
                            font-size: 20px;
                            transform: translateY(3px);
                            &._hidden {
                                display: none;
                            }
                        }
                    }
                }
            }

            table {
                td {
                    padding: 2px 8px 2px 0;
                    color: $black;
                    font-size: 14px;

                    span {
                        font-weight: 400;
                    }
                }
            }
        }
        &-video {
            &-section {
                position: relative;
                h4 {
                    margin: 0;
                    padding: 18px 0 15px 16px;
                    font-size: 16px;
                    color: $dark;

                    span {
                        width: 12px;
                        height: 12px;
                        padding-top: -8px;

                        .red-point {
                            width: inherit;
                            top: -6px;
                        }
                    }
                }

                md-chips-wrap {
                    padding-left: 16px;
                    padding-bottom: 11px;
                    box-shadow: none !important;

                    md-chip {
                        background: $medium-gray;
                        color: $white;

                        &.active {
                            background: $brand-primary;
                        }

                        &:hover {
                            cursor: pointer;
                        }
                    }
                }
            }
            &-wrapper {
                margin: 0 16px 16px;
                background: $black;
                min-height: 465px;
                position: relative;
                top: 0;
                left: 0;
                display: flex;
                height: calc(100vh / 2);
                &.full-screen {
                    position: fixed;
                    width: 100%;
                    height: 100%;
                    padding: 0;
                    margin: 0;
                }
                video {
                    height: calc(100vh / 2);
                    width: 100%;
                    min-height: 100%;
                    padding: 10px 8px;
                    position: absolute;
                }

                &._no-video {
                    margin-top: 9px;
                    display: block;

                    .no-video__icon-wrapper {
                        position: absolute;
                        left: 0;
                        right: 0;
                        top: 50%;
                        transform: translateY(-50%);
                        text-align: center;

                        .material-icons {
                            color: $white;
                            height: 66px;
                            opacity: 0.5;
                            width: 70px;
                        }

                        .icon__text {
                            font-weight: 500;
                            color: $white;
                            opacity: 0.5;
                        }
                    }

                    & .no-video__controls-wrapper {
                        position: absolute;
                        padding: 0 5%;
                        height: 30px;
                        width: 100%;
                        bottom: 40px;
                        display: flex;

                        & .controls {
                            color: #808080;

                            &._play{
                                flex: 0 0 32px;

                                & > span {
                                    font-size: 32px;
                                    transform: translate(-10px, -5px);
                                }
                            }

                            &._time {
                                flex: 1 1 auto;

                                & > span {
                                    font-size: 14px;
                                    line-height: 20px;
                                }
                            }

                            &._fullscreen,
                            &._volume,
                            &._options {
                                flex: 0 1 20px;
                                margin-left: 5%;

                                & > span {
                                    font-size: 20px;
                                    text-align: end;
                                }
                            }
                        }

                        &._progress-bar {
                            height: 40px;
                            bottom: 0;
                            justify-content: center;

                            & .progress-bar {
                                width: 100%;
                                margin-top: 5px;
                                height: 4px;
                                background-color: $white;
                                opacity: 0.5;
                                border-radius: 1px;
                            }
                        }
                    }
                }
            }
        }
    }

    @media (min-width: 992px) {
        &__tab {
            &-video-section {
                border-left: 1px solid $gray3e5;
                position: absolute;
                top: 0;
                right: 0;
                bottom: 0;
                height: auto;
                overflow: auto;

                &-wrapper {
                    padding-bottom: 60px; // space for help button
                }
            }
            &-table-wrapper {
                table {
                    height: auto;
                    td, th {
                        padding: 10px !important;
                    }
                }
            }
        }
    }

    @media (max-width: 991px) {
        &__container,
        &__section,
        .page {
            height: auto;
        }
        &__tab {
            &-table {
                &-img-wrapper {
                    white-space: nowrap !important;
                    .log-wrapper {
                        line-height: 1;
                    }
                }
                &-wrapper {
                    height: auto !important;
                    overflow: visible;
                }
                &-col {
                    &._menu {
                        & .setting-menu_button.md-button.md-icon-button {
                            max-height: 46px;
                            height: 46px;
                        }
                    }
                }
            }
            &-video {
                &-section {
                    border-bottom: 1px solid $gray3e5;
                }
                &-wrapper {
                    margin-right: 0;
                    margin-left: 0;
                }
            }
        }
    }
    @media only screen and (max-width: $md-screen-phone) {
        &__container {
            margin-right: -#{$page-padding-right-left-mobile};
            margin-left: -#{$page-padding-right-left-mobile};
        }
    }
}

@media (max-width: $md-screen-xs) {
    .testrun-info {
        &__tab {
            &-table {
                height: auto;
                width: 100%;

                &-wrapper {
                    margin-bottom: 0;
                    height: 100%;
                    overflow: auto;

                    &._mobile {
                        width: 100%;
                    }
                }

                &-row {
                    display: block;
                    height: auto;
                    position: relative;

                    &._head {
                        display: none;
                    }
                }

                &-col {
                    position: relative;
                    display: flex;
                    width: 100%;
                    font-size: 12px;
                    line-height: 16px;
                    word-wrap: break-word;

                    &._title {
                        position: relative;
                        max-height: 76px;
                        flex: 0 0 130px;
                        justify-content: start;
                        padding-left: 24px;
                        font-size: 9px;
                        opacity: 0.8;
                        text-transform: uppercase;
                    }

                    &._start {
                        display: flex;
                        padding: 11px 0;

                        &-wrapper {
                            position: relative;
                            width: 100%;
                            height: 100%;
                            max-height: 76px;
                            display: flex;
                            align-items: center;
                            justify-content: flex-start;
                        }
                    }

                    &._visuals {
                        display: flex;
                        padding: 0;

                        & .image-placeholder {
                            position: relative;
                            width: 100%;
                            height: 100%;
                            max-height: 76px;
                            margin: 11px 0;
                            display: flex;
                            align-items: center;
                            justify-content: flex-start;
                        }
                    }

                    &._status {
                        display: flex;
                        padding: 11px 0;

                        &-wrapper {
                            position: relative;
                            width: 100%;
                            height: 100%;
                            max-height: 76px;
                            display: flex;
                            justify-content: flex-start;
                            align-items: center;
                        }

                        & ._button-icon {
                            margin-left: 2px;
                            transform: translateY(2px);
                            font-size: 14px;
                        }
                    }

                    &._action {
                        justify-content: start;
                        align-items: flex-start;
                        padding: 11px 0;
                        width: auto;

                        & .log_message {
                            word-break: break-all;
                            padding-right: 16px;
                            font-size: 14px;
                            color: $black;
                        }

                        a {
                            white-space: nowrap;
                        }
                    }

                    &._menu {
                        position: absolute;
                        top: 0;
                        right: 0;
                        width: auto;

                        & ._menu-wrapper {
                            position: relative;
                        }
                    }
                }
            }

            &-additional {
                table {
                    td {
                        padding: 0 8px 0 0;
                    }
                }

                & .tab-additional__menu {
                    .menu__button {
                        padding-left: 20px;
                    }
                }
            }
        }
    }
}

._status.dropdown-content {
    max-height: none;

    & .listitem__button {
        text-align: center;
        &._active {
            background-color: rgba(1, 22, 39, 0.07);
        }
    }
}

.tab-additional__menu-content {
    & .menu__item {
        & .item-text {
            text-transform: capitalize;
            position: relative;
            margin-left: 20px;
            font-size: 14px;

            &.passed {
                &::before {
                    background-color: #43c480;
                }
            }

            &.failed {
                &::before {
                    background-color: #eb4554;
                }
            }

            &::before {
                content: '';
                position: absolute;
                display: block;
                height: 12px;
                width: 12px;
                top: 3px;
                left: -22px;
                border-radius: 50%;
            }
        }
    }
}
